# -*- coding: utf-8 -*-
"""
Created on Wed Sep 28 09:00:09 2016

@author: antoine
"""

from pile import pile
import parentheses as par


def parentheses(chaine):
    """
    Retourne un booléen indiquant si une expression contenant ( et ) est bien parenthésée.
    """


def parentheses_generale(chaine):
    """
    Retourne un booléen indiquant si une expression contenant les types de parenthèses
    listés dans l'énoncé est bien parenthésée.
    """


def evalue(L):
    """
    Calcule le résultat des opérations représentées par la liste L.
    """


def converti(chaine):
    """
    Converti la chaine donnée en liste contenant des entiers et des chaînes représentant les
    opérations.

    Les nombres, opérations et parenthèses apparaissent dans le meme ordre que dans la chaine
    de départ.
    """


def precedence(op):
    """
    Retourne un entier d'autant plus grand que la précédence de l'opération est grande,
    c'est à dire qu'elle doit être effectuée avant les autres.
    """
    if op == '(':
        return 0
    if op == "*" or op == "/":
        return 2
    if op == "+" or op == "-":
        return 1


def est_entier(arg):
    """
    Retourne un booléen représentant le fait pour arg d'être un entier ou non.
    """
    return isinstance(arg, int)


def transforme(L):
    """
    Transforme une liste de nombres/opérations en une liste post-fixée.
    """


def calcule(chaine):
    """
    Simulation d'une calculatrice élémentaire.
    """
